diff --git a/drivers/base/platform-msi.c b/drivers/base/platform-msi.c
index c4a17e5edf8b..1fd8ac26c245 100644
--- a/drivers/base/platform-msi.c
+++ b/drivers/base/platform-msi.c
@@ -110,7 +110,7 @@ static void platform_msi_free_descs(struct device *dev, int base, int nvec)
 {
 	struct msi_desc *desc, *tmp;
 
-	list_for_each_entry_safe(desc, tmp, dev_to_msi_list(dev), list) {
+	for_each_msi_entry_safe(desc, tmp, dev) {
 		if (desc->platform.msi_index >= base &&
 		    desc->platform.msi_index < (base + nvec)) {
 			list_del(&desc->list);
diff --git a/drivers/bus/fsl-mc/fsl-mc-msi.c b/drivers/bus/fsl-mc/fsl-mc-msi.c
index 8edadf05cbb7..d0a52ccfa738 100644
--- a/drivers/bus/fsl-mc/fsl-mc-msi.c
+++ b/drivers/bus/fsl-mc/fsl-mc-msi.c
@@ -214,7 +214,7 @@ static void fsl_mc_msi_free_descs(struct device *dev)
 {
 	struct msi_desc *desc, *tmp;
 
-	list_for_each_entry_safe(desc, tmp, dev_to_msi_list(dev), list) {
+	for_each_msi_entry_safe(desc, tmp, dev) {
 		list_del(&desc->list);
 		free_msi_entry(desc);
 	}
diff --git a/drivers/soc/ti/ti_sci_inta_msi.c b/drivers/soc/ti/ti_sci_inta_msi.c
index 0eb9462f609e..66f9772dcdfa 100644
--- a/drivers/soc/ti/ti_sci_inta_msi.c
+++ b/drivers/soc/ti/ti_sci_inta_msi.c
@@ -64,7 +64,7 @@ static void ti_sci_inta_msi_free_descs(struct device *dev)
 {
 	struct msi_desc *desc, *tmp;
 
-	list_for_each_entry_safe(desc, tmp, dev_to_msi_list(dev), list) {
+	for_each_msi_entry_safe(desc, tmp, dev) {
 		list_del(&desc->list);
 		free_msi_entry(desc);
 	}
diff --git a/scripts/coccinelle/iterators/for_each_msi_entry.cocci b/scripts/coccinelle/iterators/for_each_msi_entry.cocci
new file mode 100644
index 000000000000..45282f93ab6f
--- /dev/null
+++ b/scripts/coccinelle/iterators/for_each_msi_entry.cocci
@@ -0,0 +1,101 @@
+// SPDX-License-Identifier: GPL-2.0-only
+/// Use for_each_msi_entry(_safe) instead of generic iterator
+///
+// Confidence: High
+// Copyright: (C) 2020 Jacob Keller, Intel Corporation.
+// URL: http://coccinelle.lip6.fr/
+// Comments:
+// Options: --no-includes --include-headers
+
+virtual patch
+virtual context
+virtual org
+virtual report
+
+//----------------------------------------------------------
+//  For context mode
+//----------------------------------------------------------
+@depends on context@
+identifier member =~ "list";
+struct msi_desc *desc;
+struct msi_desc *tmp;
+struct device *dev;
+iterator name list_for_each_entry_safe;
+iterator name list_for_each_entry;
+statement S;
+@@
+(
+* list_for_each_entry_safe(desc, tmp, dev_to_msi_list(dev), member)
+S
+|
+* list_for_each_entry(desc, dev_to_msi_list(dev), member)
+S
+)
+
+//----------------------------------------------------------
+//  For patch mode
+//----------------------------------------------------------
+@depends on patch@
+identifier member =~ "list";
+struct msi_desc *desc;
+struct msi_desc *tmp;
+struct device *dev;
+iterator name list_for_each_entry_safe;
+iterator name for_each_msi_entry_safe;
+iterator name list_for_each_entry;
+iterator name for_each_msi_entry;
+statement S;
+@@
+(
+- list_for_each_entry_safe(desc, tmp, dev_to_msi_list(dev), member)
++ for_each_msi_entry_safe(desc, tmp, dev)
+S
+|
+- list_for_each_entry(desc, dev_to_msi_list(dev), member)
++ for_each_msi_entry(desc, dev)
+S
+)
+
+//----------------------------------------------------------
+//  For org and report mode
+//----------------------------------------------------------
+
+@r depends on (org || report )@
+identifier member =~ "list";
+struct msi_desc *desc;
+struct msi_desc *tmp;
+struct device *dev;
+iterator name list_for_each_entry_safe;
+iterator name list_for_each_entry;
+statement S;
+position p1, p2;
+@@
+(
+ list_for_each_entry_safe@p1(desc, tmp, dev_to_msi_list(dev), member) S
+|
+ list_for_each_entry@p2(desc, dev_to_msi_list(dev), member) S
+)
+
+@script:python depends on report@
+p << r.p1;
+@@
+
+coccilib.report.print_report(p[0], "WARNING: Use for_each_msi_entry_safe")
+
+@script:python depends on org@
+p << r.p1;
+@@
+
+coccilib.org.print_todo(p[0], "WARNING: Use for_each_msi_entry_safe")
+
+@script:python depends on report@
+p << r.p2;
+@@
+
+coccilib.report.print_report(p[0], "WARNING: Use for_each_msi_entry")
+
+@script:python depends on org@
+p << r.p2;
+@@
+
+coccilib.org.print_todo(p[0], "WARNING: Use for_each_msi_entry")